% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FIN_plot.R
\name{plot_sirplus}
\alias{plot_sirplus}
\title{Wrapper for primary sirplus plotting function}
\usage{
plot_sirplus(
  x,
  comp_remove = comp_remove,
  time_lim = time_lim,
  ci = ci,
  sep_compartments = sep_compartments,
  trans = trans,
  known = known,
  start_date = start_date,
  x_axis = x_axis,
  plot_title = plot_title,
  ...
)
}
\arguments{
\item{x}{An seiqhrf object returned from function \code{\link{seiqhrf}}.}

\item{comp_remove}{Compartments to remove. Suggest c(s.num, r.num)}

\item{time_lim}{Number of steps (days) to plot.}

\item{ci}{y/n to include 95% confidence intervals in sirplus plot.}

\item{sep_compartments}{y/n use faceting to show each compartment in a 
separate plot, only works if plotting a single simulation.}

\item{trans}{Y-axis transformation (e.g. log2, log10). Default = none.}

\item{known}{Dataframe with known compartment numbers to plot alongside
projections}

\item{start_date}{Date for day 0. Default: ymd("2020-03-21"),}

\item{x_axis}{Title for x-axis. Default: 'Days since beginning of epidemic'}

\item{plot_title}{Title for whole plot. Default: 'SEIQHRF plot'}

\item{...}{Additional parameters}

\item{method}{If "times", plot Duration frequency distributions.
If NULL, plot sirplus plots.}
}
\value{
ggplot2 object
}
\description{
Flexible function to generate sirplus plots (i.e. compartment counts over 
time). This function allows for plotting multiple experiments, viewing the 
plots of different scales (e.g. log2), plotting compartments separately,
adding 95% CIs, and plotting known data along side the simulations.
}
